package net.t2code.alias.Spigot.config.languages;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.config.config.SelectConfig;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;

public class SelectMessages {
    public static String selectMSG;

    public static String onlyForPlayer;
    public static String reloadStart;
    public static String reloadEnd;

    public static String noPermissionForCommand;
    public static String noSubCommand;
    public static String aliasDisabled;

    public static String buy;
    public static String noMoney;


    public static void onSelect(String Prefix) {

        T2Csend.debug(Main.getPlugin(), "§4Select language...");
        long long_ = System.currentTimeMillis();

        File msg;

        msg = new File(Main.getPath(), "languages/" + SelectConfig.getLanguage() + "_messages.yml");
        if (!msg.isFile()) {
            T2Csend.console(Prefix);
            T2Csend.console(Prefix + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Prefix + " §4The selected §c" + SelectConfig.getLanguage() + " §4language file was not found.");
            T2Csend.console(Prefix + " §6The default language §eEnglish §6is used!");
            T2Csend.console(Prefix + " §4!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            T2Csend.console(Prefix);
            msg = new File(Main.getPath(), "languages/" + "english_messages.yml");
            selectMSG = "english";
        } else selectMSG = SelectConfig.getLanguage();
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(msg);

        if (yamlConfiguration.get("Plugin.Prefix") != null) {
            Util.setPrefix(replace(yamlConfiguration.getString("Plugin.Prefix")));
        }
        onlyForPlayer = replace(yamlConfiguration.getString("Plugin.OnlyForPlayer"));
        aliasDisabled = replace(yamlConfiguration.getString("Plugin.AliasDisabled"));
        reloadStart = replace(yamlConfiguration.getString("Plugin.Reload.Start"));
        reloadEnd = replace(yamlConfiguration.getString("Plugin.Reload.End"));
        noPermissionForCommand = replace(yamlConfiguration.getString("Plugin.ForCommand"));
        noSubCommand = replace(yamlConfiguration.getString("Plugin.NoSubCommand"));
        buy = replace(yamlConfiguration.getString("Cost.Buy"));
        noMoney = replace(yamlConfiguration.getString("Cost.NoMoney"));

        T2Csend.console(Prefix + " §2Language successfully selected to: §6" + selectMSG + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

    private static String replace(String text) {
        return T2Creplace.replace(Util.getPrefix(), text);
    }
}
